Index: lemon/Makefile.am
===================================================================
--- lemon/Makefile.am	(revision 1993)
+++ lemon/Makefile.am	(revision 1999)
@@ -85,6 +85,6 @@
 	bits/alteration_notifier.h \
 	bits/array_map.h \
+	bits/base_extender.h \
 	bits/default_map.h \
-	bits/static_map.h \
 	bits/vector_map.h \
 	bits/map_extender.h \
Index: lemon/bits/alteration_notifier.h
===================================================================
--- lemon/bits/alteration_notifier.h	(revision 1996)
+++ lemon/bits/alteration_notifier.h	(revision 1999)
@@ -17,37 +17,79 @@
  */
 
-#ifndef LEMON_ALTERATION_NOTIFIER_H
-#define LEMON_ALTERATION_NOTIFIER_H
+#ifndef LEMON_BITS_ALTERATION_NOTIFIER_H
+#define LEMON_BITS_ALTERATION_NOTIFIER_H
 
 #include <vector>
-#include <algorithm>
+
+#include <lemon/bits/utility.h>
 
 ///\ingroup graphbits
 ///\file
-///\brief Observer registry for graph alteration observers.
+///\brief Observer notifier for graph alteration observers.
 
 namespace lemon {
 
-  /// \addtogroup graphbits
-  /// @{
-
-  /// \brief Registry class to register objects observes alterations in 
-  /// the graph.
-  ///
-  /// This class is a registry for the objects which observe the
-  /// alterations in a container. The alteration observers can be attached
-  /// to and detached from the registry. The observers have to inherit
-  /// from the \ref AlterationNotifier::ObserverBase and override
-  /// the virtual functions in that.
-  ///
-  /// The most important application of the alteration observing is the
-  /// dynamic map implementation.
-  ///
-  /// \param _Item The item type what the observers are observing, usually
-  /// edge or node.
+  /// \ingroup graphbits
+  ///
+  /// \brief Notifier class to notify observes about alterations in 
+  /// a container.
+  ///
+  /// The simple graph's can be refered as two containers, one node container
+  /// and one edge container. But they are not standard containers they
+  /// does not store values directly they are just key continars for more
+  /// value containers which are the node and edge maps.
+  ///
+  /// The graph's node and edge sets can be changed as we add or erase
+  /// nodes and edges in the graph. Lemon would like to handle easily
+  /// that the node and edge maps should contain values for all nodes or
+  /// edges. If we want to check on every indicing if the map contains
+  /// the current indicing key that cause a drawback in the performance
+  /// in the library. We use an other solution we notify all maps about
+  /// an alteration in the graph, which cause only drawback on the
+  /// alteration of the graph.
+  ///
+  /// This class provides an interface to the container. The \e first() and \e 
+  /// next() member functions make possible to iterate on the keys of the
+  /// container. The \e id() function returns an integer id for each key.
+  /// The \e maxId() function gives back an upper bound of the ids.
+  ///
+  /// For the proper functonality of this class, we should notify it
+  /// about each alteration in the container. The alterations have four type
+  /// as \e add(), \e erase(), \e build() and \e clear(). The \e add() and
+  /// \e erase() signals that only one or few items added or erased to or
+  /// from the graph. If all items are erased from the graph or from an empty
+  /// graph a new graph is builded then it can be signaled with the
+  /// clear() and build() members. Important rule that if we erase items 
+  /// from graph we should first signal the alteration and after that erase
+  /// them from the container, on the other way on item addition we should
+  /// first extend the container and just after that signal the alteration.
+  ///
+  /// The alteration can be observed with a class inherited from the
+  /// \e ObserverBase nested class. The signals can be handled with
+  /// overriding the virtual functions defined in the base class.
+  /// The observer base can be attached to the notifier with the
+  /// \e attach() member and can be detached with detach() function.
+  ///
+  /// Alteration observers try to be exception safe. This can be achived
+  /// when the observers does not throw exception on \e erase() and 
+  /// \e clear(). Less strict condition is that the \e erase() should
+  /// not throw exception after an \e add() with the same parameter and
+  /// the \e clear() should not throw exception after a \e build(). 
+  ///
+  /// There are some place when the alteration observing is not completly
+  /// reliable. If we want to carry out the node degree in the graph
+  /// as in the \ref InDegMap and we use the reverseEdge that cause 
+  /// unreliable functionality. Because the alteration observing signals
+  /// only erasing and adding but not the reversing it will stores bad
+  /// degrees. The sub graph adaptors cannot signal the alterations because
+  /// just a setting in the filter map can modify the graph and this cannot
+  /// be watched in any way.
+  ///
+  /// \param _Container The container which is observed.
+  /// \param _Item The item type which is obserbved.
   ///
   /// \author Balazs Dezso
 
-  template <typename _Item>
+  template <typename _Container, typename _Item>
   class AlterationNotifier {
   public:
@@ -55,8 +97,9 @@
     typedef True Notifier;
 
+    typedef _Container Container;
     typedef _Item Item;
 
-    /// ObserverBase is the base class for the observers.
-	
+    /// \brief ObserverBase is the base class for the observers.
+    ///
     /// ObserverBase is the abstract base class for the observers.
     /// It will be notified about an item was inserted into or
@@ -76,5 +119,5 @@
     class ObserverBase {
     protected:
-      typedef AlterationNotifier Registry;
+      typedef AlterationNotifier Notifier;
 
       friend class AlterationNotifier;
@@ -84,13 +127,29 @@
       /// Default constructor for ObserverBase.
       /// 
-      ObserverBase() : registry(0) {}
-
+      ObserverBase() : notifier(0) {}
+
+      /// \brief Constructor which attach the observer into notifier.
+      ///
+      /// Constructor which attach the observer into notifier.
+      ObserverBase(AlterationNotifier& _notifier) {
+        attach(_notifier);
+      }
+
+      /// \brief Constructor which attach the obserever to the same notifier.
+      ///
+      /// Constructor which attach the obserever to the same notifier as
+      /// the other observer is attached to. 
       ObserverBase(const ObserverBase& copy) {
 	if (copy.attached()) {
-	  copy.getRegistry()->attach(*this);
+          attach(*copy.getNotifier());
 	}
       }
 	
-      virtual ~ObserverBase() {}
+      /// \brief Destructor
+      virtual ~ObserverBase() {
+        if (attached()) {
+          detach();
+        }
+      }
 
       /// \brief Attaches the observer into an AlterationNotifier.
@@ -98,7 +157,7 @@
       /// This member attaches the observer into an AlterationNotifier.
       ///
-      void attach(AlterationNotifier& r) {
-	registry = &r;
-	registry->attach(*this);
+      void attach(AlterationNotifier& _notifier) {
+	notifier = &_notifier;
+	notifier->attach(*this);
       }
 
@@ -108,19 +167,18 @@
       ///
       void detach() {
-	if (registry) {
-	  registry->detach(*this);
-	}
-      }
-	
-
-      /// Gives back a pointer to the registry what the map attached into.
-
-      /// This function gives back a pointer to the registry what the map
+        notifier->detach(*this);
+      }
+	
+
+      /// \brief Gives back a pointer to the notifier which the map 
       /// attached into.
       ///
-      Registry* getRegistry() const { return const_cast<Registry*>(registry); }
+      /// This function gives back a pointer to the notifier which the map
+      /// attached into.
+      ///
+      Notifier* getNotifier() const { return const_cast<Notifier*>(notifier); }
       
-      /// Gives back true when the observer is attached into a registry.
-      bool attached() const { return registry != 0; }
+      /// Gives back true when the observer is attached into a notifier.
+      bool attached() const { return notifier != 0; }
 
     private:
@@ -130,6 +188,6 @@
     protected:
       
-      Registry* registry;
-      int registry_index;
+      Notifier* notifier;
+      int notifier_index;
 
       /// \brief The member function to notificate the observer about an
@@ -150,7 +208,15 @@
 
       virtual void add(const std::vector<Item>& items) {
-	for (int i = 0; i < (int)items.size(); ++i) {
-	  add(items[i]);
-	}
+        int i;
+        try {
+          for (i = 0; i < (int)items.size(); ++i) {
+            add(items[i]);
+          }
+        } catch (...) {
+          for (int j = 0; j < i; ++j) {
+            add(items[j]);
+          }          
+          throw;
+        }
       }
 
@@ -171,7 +237,7 @@
       /// subclasses.
       virtual void erase(const std::vector<Item>& items) {
-	for (int i = 0; i < (int)items.size(); ++i) {
-	  erase(items[i]);
-	}
+        for (int i = 0; i < (int)items.size(); ++i) {
+          erase(items[i]);
+        }
       }
 
@@ -183,5 +249,18 @@
       /// overrided in the subclasses.
 
-      virtual void build() = 0;
+      virtual void build() {
+        Item it;
+        try {
+          for (notifier->first(it); it != INVALID; notifier->next(it)) {
+            add(it);
+          }
+        } catch (...) {
+          Item jt;
+          for (notifier->first(jt); jt != it; notifier->next(jt)) {
+            erase(jt);
+          }
+          throw;
+        }
+      }
 
       /// \brief The member function to notificate the observer about all
@@ -190,90 +269,133 @@
       /// The clear() member function notificates the observer about all
       /// items are erased from the container. It have to be overrided in
-      /// the subclasses.
-      
-      virtual void clear() = 0;
+      /// the subclasses.      
+      virtual void clear() {
+        Item it;
+        for (notifier->first(it); it != INVALID; notifier->next(it)) {
+          erase(it);
+        }
+      }
 
     };
 	
   protected:
-	
-
-    typedef std::vector<ObserverBase*> Container; 
-
-    Container container;
+
+    const Container* container;
+
+    typedef std::vector<ObserverBase*> Observers; 
+    Observers observers;
 
 		
   public:
 
-    /// Default constructor.
-	
+    /// \brief Default constructor.
     ///
     /// The default constructor of the AlterationNotifier. 
-    /// It creates an empty registry.
-    AlterationNotifier() {}
-
-    /// Copy Constructor of the AlterationNotifier. 
-	
+    /// It creates an empty notifier.
+    AlterationNotifier() 
+      : container(0) {}
+
+    /// \brief Constructor.
+    ///
+    /// Constructor with the observed container parameter.
+    AlterationNotifier(const Container& _container) 
+      : container(&_container) {}
+
+    /// \brief Copy Constructor of the AlterationNotifier. 
+    ///
     /// Copy constructor of the AlterationNotifier. 
-    /// It creates only an empty registry because the copiable
-    /// registry's observers have to be registered still into that registry.
-    AlterationNotifier(const AlterationNotifier&) {}
-
-    /// Assign operator.
+    /// It creates only an empty notifier because the copiable
+    /// notifier's observers have to be registered still into that notifier.
+    AlterationNotifier(const AlterationNotifier& _notifier) 
+      : container(_notifier.container) {}
+
+    /// \brief Destructor.
+    ///		
+    /// Destructor of the AlterationNotifier.
+    ///
+    ~AlterationNotifier() {
+      typename Observers::iterator it;
+      for (it = observers.begin(); it != observers.end(); ++it) {
+	(*it)->notifier = 0;
+      }
+    }
+
+    /// \brief Sets the container.
+    ///
+    /// Sets the container.
+    void setContainer(const Container& _container) {
+      container = &_container;
+    }
+
+  protected:
+
+    AlterationNotifier& operator=(const AlterationNotifier&);
+
+  public:
+
+
+
+    /// \brief First item in the container.
+    ///
+    /// Returns the first item in the container. It is
+    /// for start the iteration on the container.
+    void first(Item& item) const {
+      container->first(item);
+    }
+
+    /// \brief Next item in the container.
+    ///
+    /// Returns the next item in the container. It is
+    /// for iterate on the container.
+    void next(Item& item) const {
+      container->next(item);
+    }
+
+    /// \brief Returns the id of the item.
+    ///
+    /// Returns the id of the item provided by the container.
+    int id(const Item& item) const {
+      return container->id(item);
+    }
+
+    /// \brief Returns the maximum id of the container.
+    ///
+    /// Returns the maximum id of the container.
+    int maxId() const {
+      return container->maxId(Item());
+    }
 		
-    /// Assign operator for the AlterationNotifier. 
-    /// It makes the notifier only empty because the copiable
-    /// notifier's observers have to be registered still into that registry.
-    AlterationNotifier& operator=(const AlterationNotifier&) {
-      typename Container::iterator it;
-      for (it = container.begin(); it != container.end(); ++it) {
-	(*it)->registry = 0;
-      }
-    }
-
-    /// Destructor.
-				
-    /// Destructor of the AlterationNotifier.
-    ///
-    ~AlterationNotifier() {
-      typename Container::iterator it;
-      for (it = container.begin(); it != container.end(); ++it) {
-	(*it)->registry = 0;
-      }
-    }
-	
-	
   protected:
 
     void attach(ObserverBase& observer) {
-      container.push_back(&observer);
-      observer.registry = this;
-      observer.registry_index = container.size()-1;
+      observers.push_back(&observer);
+      observer.notifier = this;
+      observer.notifier_index = observers.size() - 1;
     } 
 
-    void detach(ObserverBase& base) {
-      container.back()->registry_index = base.registry_index; 
-      container[base.registry_index] = container.back();
-      container.pop_back();
-      base.registry = 0;
+    void detach(ObserverBase& observer) {
+      observers.back()->notifier_index = observer.notifier_index; 
+      observers[observer.notifier_index] = observers.back();
+      observers.pop_back();
+      observer.notifier = 0;
     }
 
   public:
 	
-    /// \brief Notifies all the registered observers about an Item added to 
-    /// the container.
-    ///
-    /// It notifies all the registered observers about an Item added to 
+    /// \brief Notifies all the registed observers about an item added to 
+    /// the container.
+    ///
+    /// It notifies all the registed observers about an item added to 
     /// the container.
     /// 
     void add(const Item& item) {
-      typename Container::iterator it;
+      typename Observers::iterator it;
       try {
-        for (it = container.begin(); it != container.end(); ++it) {
+        for (it = observers.begin(); it != observers.end(); ++it) {
           (*it)->add(item);
         }
       } catch (...) {
-        typename Container::iterator jt;
-        for (jt = container.begin(); jt != it; ++it) {
+        typename Observers::iterator jt;
+        for (jt = observers.begin(); jt != it; ++jt) {
           (*it)->erase(item);
         }
@@ -282,19 +404,19 @@
     }	
 
-    /// \brief Notifies all the registered observers about more Item added to 
-    /// the container.
-    ///
-    /// It notifies all the registered observers about more Item added to 
+    /// \brief Notifies all the registed observers about more item added to 
+    /// the container.
+    ///
+    /// It notifies all the registed observers about more item added to 
     /// the container.
     /// 
     void add(const std::vector<Item>& items) {
-      typename Container::iterator it;
+      typename Observers::iterator it;
       try {
-        for (it = container.begin(); it != container.end(); ++it) {
+        for (it = observers.begin(); it != observers.end(); ++it) {
           (*it)->add(items);
         }
       } catch (...) {
-        typename Container::iterator jt;
-        for (jt = container.begin(); jt != it; ++it) {
+        typename Observers::iterator jt;
+        for (jt = observers.begin(); jt != it; ++jt) {
           (*it)->erase(items);
         }
@@ -303,44 +425,44 @@
     }	
 
-    /// \brief Notifies all the registered observers about an Item erased from 
+    /// \brief Notifies all the registed observers about an item erased from 
     /// the container.
     ///	
-    /// It notifies all the registered observers about an Item erased from 
+    /// It notifies all the registed observers about an item erased from 
     /// the container.
     /// 
     void erase(const Item& key) {
-      typename Container::iterator it;
-      for (it = container.begin(); it != container.end(); ++it) {
+      typename Observers::iterator it;
+      for (it = observers.begin(); it != observers.end(); ++it) {
 	(*it)->erase(key);
       }
     }
 
-    /// \brief Notifies all the registered observers about more Item erased  
+    /// \brief Notifies all the registed observers about more item erased  
     /// from the container.
     ///	
-    /// It notifies all the registered observers about more Item erased from 
+    /// It notifies all the registed observers about more item erased from 
     /// the container.
     /// 
     void erase(const std::vector<Item>& items) {
-      typename Container::iterator it;
-      for (it = container.begin(); it != container.end(); ++it) {
+      typename Observers::iterator it;
+      for (it = observers.begin(); it != observers.end(); ++it) {
 	(*it)->erase(items);
       }
     }
 
-    /// \brief Notifies all the registered observers about the container is 
+    /// \brief Notifies all the registed observers about the container is 
     /// built.
     ///		
-    /// Notifies all the registered observers about the container is built
+    /// Notifies all the registed observers about the container is built
     /// from an empty container.
     void build() {
-      typename Container::iterator it;
+      typename Observers::iterator it;
       try {
-        for (it = container.begin(); it != container.end(); ++it) {
+        for (it = observers.begin(); it != observers.end(); ++it) {
           (*it)->build();
         }
       } catch (...) {
-        typename Container::iterator jt;
-        for (jt = container.begin(); jt != it; ++it) {
+        typename Observers::iterator jt;
+        for (jt = observers.begin(); jt != it; ++jt) {
           (*it)->clear();
         }
@@ -350,12 +472,12 @@
 
 
-    /// \brief Notifies all the registered observers about all Items are 
+    /// \brief Notifies all the registed observers about all items are 
     /// erased.
     ///
-    /// Notifies all the registered observers about all Items are erased
+    /// Notifies all the registed observers about all items are erased
     /// from the container.
     void clear() {
-      typename Container::iterator it;
-      for (it = container.begin(); it != container.end(); ++it) {
+      typename Observers::iterator it;
+      for (it = observers.begin(); it != observers.end(); ++it) {
 	(*it)->clear();
       }
@@ -363,8 +485,4 @@
   };
 
-  
-/// @}
-  
-
 }
 
Index: lemon/bits/array_map.h
===================================================================
--- lemon/bits/array_map.h	(revision 1996)
+++ lemon/bits/array_map.h	(revision 1999)
@@ -21,13 +21,11 @@
 
 #include <memory>
-#include <lemon/bits/map_extender.h>
+
+#include <lemon/bits/traits.h>
 #include <lemon/bits/alteration_notifier.h>
-#include <lemon/concept_check.h>
-#include <lemon/concept/maps.h>
 
 /// \ingroup graphbits
 /// \file
-/// \brief Graph maps that construct and destruct
-/// their elements dynamically.
+/// \brief Graph map based on the array storage.
 
 namespace lemon {
@@ -38,20 +36,18 @@
   ///
   /// The ArrayMap template class is graph map structure what
-  /// automatically indates the map when a key is added to or erased from
+  /// automatically updates the map when a key is added to or erased from
   /// the map. This map uses the allocators to implement 
   /// the container functionality.
   ///
-  /// The template parameter is the AlterationNotifier that the maps
-  /// will belong to and the Value.
-
-  template <typename _Graph, 
-	    typename _Item,
-	    typename _Value>
-  class ArrayMap : public AlterationNotifier<_Item>::ObserverBase {
-
-    typedef _Item Item;
+  /// The template parameter is the Graph the current Item type and
+  /// the Value type of the map.
+  template <typename _Graph, typename _Item, typename _Value>
+  class ArrayMap 
+    : public ItemSetTraits<_Graph, _Item>::ItemNotifier::ObserverBase {
   public:
     /// The graph type of the maps. 
     typedef _Graph Graph;
+    /// The item type of the map.
+    typedef _Item Item;
     /// The reference map tag.
     typedef True ReferenceMapTag;
@@ -61,4 +57,5 @@
     /// The value type of the map.
     typedef _Value Value;
+
     /// The const reference type of the map.
     typedef const _Value& ConstReference;
@@ -66,19 +63,13 @@
     typedef _Value& Reference;
 
-    typedef const Value ConstValue;
-    typedef Value* Pointer;
-    typedef const Value* ConstPointer;
-
-    typedef AlterationNotifier<_Item> Registry;
+    /// The notifier type.
+    typedef typename ItemSetTraits<_Graph, _Item>::ItemNotifier Notifier;
 
     /// The MapBase of the Map which imlements the core regisitry function.
-    typedef typename Registry::ObserverBase Parent;
+    typedef typename Notifier::ObserverBase Parent;
 		
-
-
   private:
     typedef std::allocator<Value> Allocator;
 
-
   public:
 
@@ -86,10 +77,11 @@
     ///
     /// Graph initialized map constructor.
-    ArrayMap(const Graph& _g) : graph(&_g) {
+    ArrayMap(const Graph& graph) {
+      Parent::attach(graph.getNotifier(Item()));
+      allocate_memory();
+      Notifier* notifier = Parent::getNotifier();
       Item it;
-      attach(_g.getNotifier(Item()));
-      allocate_memory();
-      for (graph->first(it); it != INVALID; graph->next(it)) {
-	int id = graph->id(it);;
+      for (notifier->first(it); it != INVALID; notifier->next(it)) {
+	int id = notifier->id(it);;
 	allocator.construct(&(values[id]), Value());
       }								
@@ -99,11 +91,12 @@
     ///
     /// It constructs a map and initialize all of the the map. 
-    ArrayMap(const Graph& _g, const Value& _v) : graph(&_g) {
+    ArrayMap(const Graph& graph, const Value& value) {
+      Parent::attach(graph.getNotifier(Item()));
+      allocate_memory();
+      Notifier* notifier = Parent::getNotifier();
       Item it;
-      attach(_g.getNotifier(_Item()));
-      allocate_memory();
-      for (graph->first(it); it != INVALID; graph->next(it)) {
-	int id = graph->id(it);;
-	allocator.construct(&(values[id]), _v);
+      for (notifier->first(it); it != INVALID; notifier->next(it)) {
+	int id = notifier->id(it);;
+	allocator.construct(&(values[id]), value);
       }								
     }
@@ -112,14 +105,15 @@
     ///
     /// Constructor to copy a map of the same map type.     
-    ArrayMap(const ArrayMap& copy) : Parent(), graph(copy.graph) {
+    ArrayMap(const ArrayMap& copy) : Parent() {
       if (copy.attached()) {
-	attach(*copy.getRegistry());
+	attach(*copy.getNotifier());
       }
       capacity = copy.capacity;
       if (capacity == 0) return;
       values = allocator.allocate(capacity);
+      Notifier* notifier = Parent::getNotifier();
       Item it;
-      for (graph->first(it); it != INVALID; graph->next(it)) {
-	int id = graph->id(it);;
+      for (notifier->first(it); it != INVALID; notifier->next(it)) {
+	int id = notifier->id(it);;
 	allocator.construct(&(values[id]), copy.values[id]);
       }
@@ -146,9 +140,4 @@
     using Parent::attached;
 
-    const Graph* getGraph() {
-      return graph;
-    }
-
-
   public:
 
@@ -158,5 +147,5 @@
     /// actual keys of the graph. 
     Value& operator[](const Key& key) {
-      int id = graph->id(key);
+      int id = Parent::getNotifier()->id(key);
       return values[id];
     } 
@@ -167,5 +156,5 @@
     /// actual keys of the graph. 
     const Value& operator[](const Key& key) const {
-      int id = graph->id(key);
+      int id = Parent::getNotifier()->id(key);
       return values[id];
     }
@@ -181,8 +170,11 @@
   protected:
 
-    /// Add a new key to the map. It called by the map registry.
-         
+    /// \brief Adds a new key to the map.
+    ///		
+    /// It adds a new key to the map. It called by the observer notifier
+    /// and it overrides the add() member function of the observer base.     
     virtual void add(const Key& key) {
-      int id = graph->id(key);
+      Notifier* notifier = Parent::getNotifier();
+      int id = notifier->id(key);
       if (id >= capacity) {
 	int new_capacity = (capacity == 0 ? 1 : capacity);
@@ -192,6 +184,6 @@
 	Value* new_values = allocator.allocate(new_capacity);
 	Item it;
-	for (graph->first(it); it != INVALID; graph->next(it)) {
-	  int jd = graph->id(it);;
+	for (notifier->first(it); it != INVALID; notifier->next(it)) {
+	  int jd = notifier->id(it);;
 	  if (id != jd) {
 	    allocator.construct(&(new_values[jd]), values[jd]);
@@ -206,8 +198,13 @@
     }
 
+    /// \brief Adds more new keys to the map.
+    ///		
+    /// It adds more new keys to the map. It called by the observer notifier
+    /// and it overrides the add() member function of the observer base.     
     virtual void add(const std::vector<Key>& keys) {
+      Notifier* notifier = Parent::getNotifier();
       int max_id = -1;
       for (int i = 0; i < (int)keys.size(); ++i) {
-	int id = graph->id(keys[i]);
+	int id = notifier->id(keys[i]);
 	if (id > max_id) {
 	  max_id = id;
@@ -221,9 +218,9 @@
 	Value* new_values = allocator.allocate(new_capacity);
 	Item it;
-	for (graph->first(it); it != INVALID; graph->next(it)) {
-	  int id = graph->id(it);
+	for (notifier->first(it); it != INVALID; notifier->next(it)) {
+	  int id = notifier->id(it);
 	  bool found = false;
 	  for (int i = 0; i < (int)keys.size(); ++i) {
-	    int jd = graph->id(keys[i]);
+	    int jd = notifier->id(keys[i]);
 	    if (id == jd) {
 	      found = true;
@@ -240,37 +237,53 @@
       }
       for (int i = 0; i < (int)keys.size(); ++i) {
-	int id = graph->id(keys[i]);
+	int id = notifier->id(keys[i]);
 	allocator.construct(&(values[id]), Value());
       }
     }
 		
-    /// Erase a key from the map. It called by the map registry.
-     
+    /// \brief Erase a key from the map.
+    ///
+    /// Erase a key from the map. It called by the observer notifier
+    /// and it overrides the erase() member function of the observer base.     
     virtual void erase(const Key& key) {
-      int id = graph->id(key);
+      int id = Parent::getNotifier()->id(key);
       allocator.destroy(&(values[id]));
     }
 
+    /// \brief Erase more keys from the map.
+    ///
+    /// Erase more keys from the map. It called by the observer notifier
+    /// and it overrides the erase() member function of the observer base.     
     virtual void erase(const std::vector<Key>& keys) {
       for (int i = 0; i < (int)keys.size(); ++i) {
-	int id = graph->id(keys[i]);
+	int id = Parent::getNotifier()->id(keys[i]);
 	allocator.destroy(&(values[id]));
       }
     }
 
+    /// \brief Buildes the map.
+    ///	
+    /// It buildes the map. It called by the observer notifier
+    /// and it overrides the build() member function of the observer base. 
     virtual void build() {
+      Notifier* notifier = Parent::getNotifier();
       allocate_memory();
       Item it;
-      for (graph->first(it); it != INVALID; graph->next(it)) {
-	int id = graph->id(it);;
+      for (notifier->first(it); it != INVALID; notifier->next(it)) {
+	int id = notifier->id(it);;
 	allocator.construct(&(values[id]), Value());
       }								
     }
 
+    /// \brief Clear the map.
+    ///
+    /// It erase all items from the map. It called by the observer notifier
+    /// and it overrides the clear() member function of the observer base.     
     virtual void clear() {	
+      Notifier* notifier = Parent::getNotifier();
       if (capacity != 0) {
 	Item it;
-	for (graph->first(it); it != INVALID; graph->next(it)) {
-	  int id = graph->id(it);
+	for (notifier->first(it); it != INVALID; notifier->next(it)) {
+	  int id = notifier->id(it);
 	  allocator.destroy(&(values[id]));
 	}								
@@ -283,5 +296,5 @@
       
     void allocate_memory() {
-      int max_id = graph->maxId(_Item());
+      int max_id = Parent::getNotifier()->maxId();
       if (max_id == -1) {
 	capacity = 0;
@@ -296,5 +309,4 @@
     }      
 
-    const Graph* graph;
     int capacity;
     Value* values;
